diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/internet-apps/test/ping-test.cc ns-3.43/src/internet-apps/test/ping-test.cc
--- ns-3.42/src/internet-apps/test/ping-test.cc	2024-05-29 15:29:46.952073000 -0700
+++ ns-3.43/src/internet-apps/test/ping-test.cc	2024-10-09 16:41:09.880655800 -0700
@@ -3,18 +3,7 @@
  * Copyright (c) 2022 Universita' di Firenze, Italy
  * Copyright (c) 2022 Tom Henderson
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Chandrakant Jena <chandrakant.barcelona@gmail.com>
  *          Tommaso Pecorella <tommaso.pecorella@unifi.it>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-active-scan.cc ns-3.43/src/lr-wpan/examples/lr-wpan-active-scan.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-active-scan.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-active-scan.cc	2024-10-09 16:41:09.896656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Tokushima University, Japan.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author:  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-bootstrap.cc ns-3.43/src/lr-wpan/examples/lr-wpan-bootstrap.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2024-10-09 16:41:09.896656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Tokushima University, Japan.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author:  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
  */
@@ -369,17 +358,9 @@
     mobility.SetPositionAllocator(listPositionAlloc);
     mobility.Install(coordinators);
 
-    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
-    Ptr<LogDistancePropagationLossModel> propModel =
-        CreateObject<LogDistancePropagationLossModel>();
-    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
-        CreateObject<ConstantSpeedPropagationDelayModel>();
-
-    channel->AddPropagationLossModel(propModel);
-    channel->SetPropagationDelayModel(delayModel);
-
     LrWpanHelper lrWpanHelper;
-    lrWpanHelper.SetChannel(channel);
+    lrWpanHelper.SetPropagationDelayModel("ns3::ConstantSpeedPropagationDelayModel");
+    lrWpanHelper.AddPropagationLossModel("ns3::LogDistancePropagationLossModel");
 
     NetDeviceContainer lrwpanDevices = lrWpanHelper.Install(nodes);
     lrwpanDevices.Add(lrWpanHelper.Install(coordinators));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-data.cc ns-3.43/src/lr-wpan/examples/lr-wpan-data.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-data.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-data.cc	2024-10-09 16:41:09.896656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author:  Tom Henderson <thomas.r.henderson@boeing.com>
  */
@@ -91,10 +80,11 @@
 
     cmd.Parse(argc, argv);
 
-    LrWpanHelper lrWpanHelper;
     if (verbose)
     {
-        lrWpanHelper.EnableLogComponents();
+        LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
+        LogComponentEnable("LrWpanPhy", LOG_LEVEL_ALL);
+        LogComponentEnable("LrWpanMac", LOG_LEVEL_ALL);
     }
 
     // Enable calculation of FCS in the trailers. Only necessary when interacting with real devices
@@ -107,19 +97,6 @@
     Ptr<LrWpanNetDevice> dev0 = CreateObject<LrWpanNetDevice>();
     Ptr<LrWpanNetDevice> dev1 = CreateObject<LrWpanNetDevice>();
 
-    if (!extended)
-    {
-        dev0->SetAddress(Mac16Address("00:01"));
-        dev1->SetAddress(Mac16Address("00:02"));
-    }
-    else
-    {
-        Ptr<LrWpanMac> mac0 = dev0->GetMac();
-        Ptr<LrWpanMac> mac1 = dev1->GetMac();
-        mac0->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:01"));
-        mac1->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:02"));
-    }
-
     // Each device must be attached to the same channel
     Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
     Ptr<LogDistancePropagationLossModel> propModel =
@@ -136,6 +113,33 @@
     n0->AddDevice(dev0);
     n1->AddDevice(dev1);
 
+    // Note: This setup, which has been done manually here, can be simplified using the LrWpanHelper
+    // class. The LrWpanHelper can be used to set up the propagation loss and delay models in many
+    // devices in a simpler way. The following is an equivalent, simplified setup:
+    //
+    //    LrWpanHelper lrWpanHelper;
+    //    lrWpanHelper.SetPropagationDelayModel("ns3::ConstantSpeedPropagationDelayModel");
+    //    lrWpanHelper.AddPropagationLossModel("ns3::LogDistancePropagationLossModel");
+    //    NodeContainer nodes;
+    //    nodes.Create(2);
+    //    NetDeviceContainer devices = lrWpanHelper.Install(nodes);
+    //    Ptr<LrWpanNetDevice> dev0 = devices.Get(0)->GetObject<LrWpanNetDevice>();
+    //    Ptr<LrWpanNetDevice> dev1 = devices.Get(1)->GetObject<LrWpanNetDevice>();
+
+    // Set 16-bit short addresses if extended is false, otherwise use 64-bit extended addresses
+    if (!extended)
+    {
+        dev0->SetAddress(Mac16Address("00:01"));
+        dev1->SetAddress(Mac16Address("00:02"));
+    }
+    else
+    {
+        Ptr<LrWpanMac> mac0 = dev0->GetMac();
+        Ptr<LrWpanMac> mac1 = dev1->GetMac();
+        mac0->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:01"));
+        mac1->SetExtendedAddress(Mac64Address("00:00:00:00:00:00:00:02"));
+    }
+
     // Trace state changes in the phy
     dev0->GetPhy()->TraceConnect("TrxState",
                                  std::string("phy0"),
@@ -170,12 +174,6 @@
     cb3 = MakeCallback(&DataIndication);
     dev1->GetMac()->SetMcpsDataIndicationCallback(cb3);
 
-    // Tracing
-    lrWpanHelper.EnablePcapAll(std::string("lr-wpan-data"), true);
-    AsciiTraceHelper ascii;
-    Ptr<OutputStreamWrapper> stream = ascii.CreateFileStream("lr-wpan-data.tr");
-    lrWpanHelper.EnableAsciiAll(stream);
-
     // The below should trigger two callbacks when end-to-end data is working
     // 1) DataConfirm callback is called
     // 2) DataIndication callback is called with value of 50
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-ed-scan.cc ns-3.43/src/lr-wpan/examples/lr-wpan-ed-scan.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-ed-scan.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-ed-scan.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Tokushima University, Japan.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author:  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc ns-3.43/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Tom Henderson <thomas.r.henderson@boeing.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-error-model-plot.cc ns-3.43/src/lr-wpan/examples/lr-wpan-error-model-plot.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-error-model-plot.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-error-model-plot.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gary Pei <guangyu.pei@boeing.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-mlme.cc ns-3.43/src/lr-wpan/examples/lr-wpan-mlme.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-mlme.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-mlme.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 Ritsumeikan University, Shiga, Japan.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author:  Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
  */
@@ -98,29 +87,20 @@
     LrWpanHelper lrWpanHelper;
 
     // Create 2 nodes, and a NetDevice for each one
-    Ptr<Node> n0 = CreateObject<Node>();
-    Ptr<Node> n1 = CreateObject<Node>();
 
-    Ptr<LrWpanNetDevice> dev0 = CreateObject<LrWpanNetDevice>();
-    Ptr<LrWpanNetDevice> dev1 = CreateObject<LrWpanNetDevice>();
+    NodeContainer nodes;
+    nodes.Create(2);
+
+    // Use LrWpanHelper to create devices and assign them to nodes
+    lrWpanHelper.SetPropagationDelayModel("ns3::ConstantSpeedPropagationDelayModel");
+    lrWpanHelper.AddPropagationLossModel("ns3::LogDistancePropagationLossModel");
+    NetDeviceContainer devices = lrWpanHelper.Install(nodes);
+    Ptr<LrWpanNetDevice> dev0 = devices.Get(0)->GetObject<LrWpanNetDevice>();
+    Ptr<LrWpanNetDevice> dev1 = devices.Get(1)->GetObject<LrWpanNetDevice>();
 
     dev0->SetAddress(Mac16Address("00:01"));
     dev1->SetAddress(Mac16Address("00:02"));
 
-    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
-    Ptr<LogDistancePropagationLossModel> propModel =
-        CreateObject<LogDistancePropagationLossModel>();
-    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
-        CreateObject<ConstantSpeedPropagationDelayModel>();
-    channel->AddPropagationLossModel(propModel);
-    channel->SetPropagationDelayModel(delayModel);
-
-    dev0->SetChannel(channel);
-    dev1->SetChannel(channel);
-
-    n0->AddDevice(dev0);
-    n1->AddDevice(dev1);
-
     ///////////////// Mobility   ///////////////////////
     Ptr<ConstantPositionMobilityModel> sender0Mobility =
         CreateObject<ConstantPositionMobilityModel>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-orphan-scan.cc ns-3.43/src/lr-wpan/examples/lr-wpan-orphan-scan.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Tokushima University, Japan.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author:  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-packet-print.cc ns-3.43/src/lr-wpan/examples/lr-wpan-packet-print.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-packet-print.cc	2024-05-29 15:29:46.972073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-packet-print.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author:  Tom Henderson <thomas.r.henderson@boeing.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-per-plot.cc ns-3.43/src/lr-wpan/examples/lr-wpan-per-plot.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-per-plot.cc	2024-05-29 15:29:46.976073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-per-plot.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Tokushima University, Japan
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
  *          Tommaso Pecorella <tommaso.pecorella@unifi.it>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/examples/lr-wpan-phy-test.cc ns-3.43/src/lr-wpan/examples/lr-wpan-phy-test.cc
--- ns-3.42/src/lr-wpan/examples/lr-wpan-phy-test.cc	2024-05-29 15:29:46.976073300 -0700
+++ ns-3.43/src/lr-wpan/examples/lr-wpan-phy-test.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gary Pei <guangyu.pei@boeing.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/helper/lr-wpan-helper.cc ns-3.43/src/lr-wpan/helper/lr-wpan-helper.cc
--- ns-3.42/src/lr-wpan/helper/lr-wpan-helper.cc	2024-05-29 15:29:46.976073300 -0700
+++ ns-3.43/src/lr-wpan/helper/lr-wpan-helper.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors:
  *  Gary Pei <guangyu.pei@boeing.com>
@@ -27,8 +16,6 @@
 #include <ns3/lr-wpan-net-device.h>
 #include <ns3/mobility-model.h>
 #include <ns3/multi-model-spectrum-channel.h>
-#include <ns3/propagation-delay-model.h>
-#include <ns3/propagation-loss-model.h>
 #include <ns3/single-model-spectrum-channel.h>
 
 namespace ns3
@@ -64,34 +51,12 @@
 
 LrWpanHelper::LrWpanHelper()
 {
-    m_channel = CreateObject<SingleModelSpectrumChannel>();
-
-    Ptr<LogDistancePropagationLossModel> lossModel =
-        CreateObject<LogDistancePropagationLossModel>();
-    m_channel->AddPropagationLossModel(lossModel);
-
-    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
-        CreateObject<ConstantSpeedPropagationDelayModel>();
-    m_channel->SetPropagationDelayModel(delayModel);
+    m_useMultiModelSpectrumChannel = false;
 }
 
 LrWpanHelper::LrWpanHelper(bool useMultiModelSpectrumChannel)
 {
-    if (useMultiModelSpectrumChannel)
-    {
-        m_channel = CreateObject<MultiModelSpectrumChannel>();
-    }
-    else
-    {
-        m_channel = CreateObject<SingleModelSpectrumChannel>();
-    }
-    Ptr<LogDistancePropagationLossModel> lossModel =
-        CreateObject<LogDistancePropagationLossModel>();
-    m_channel->AddPropagationLossModel(lossModel);
-
-    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
-        CreateObject<ConstantSpeedPropagationDelayModel>();
-    m_channel->SetPropagationDelayModel(delayModel);
+    m_useMultiModelSpectrumChannel = useMultiModelSpectrumChannel;
 }
 
 LrWpanHelper::~LrWpanHelper()
@@ -178,6 +143,45 @@
 NetDeviceContainer
 LrWpanHelper::Install(NodeContainer c)
 {
+    if (!m_channel)
+    {
+        if (m_useMultiModelSpectrumChannel)
+        {
+            m_channel = CreateObject<MultiModelSpectrumChannel>();
+        }
+        else
+        {
+            m_channel = CreateObject<SingleModelSpectrumChannel>();
+        }
+        if (!m_propagationDelay.IsTypeIdSet())
+        {
+            SetPropagationDelayModel("ns3::ConstantSpeedPropagationDelayModel");
+        }
+        if (m_propagationLoss.empty())
+        {
+            AddPropagationLossModel("ns3::LogDistancePropagationLossModel");
+        }
+
+        for (auto i = m_propagationLoss.begin(); i != m_propagationLoss.end(); ++i)
+        {
+            Ptr<PropagationLossModel> cur = (*i).Create<PropagationLossModel>();
+            m_channel->AddPropagationLossModel(cur);
+        }
+        Ptr<PropagationDelayModel> delay = m_propagationDelay.Create<PropagationDelayModel>();
+        m_channel->SetPropagationDelayModel(delay);
+    }
+    else
+    {
+        if (!m_channel->GetPropagationDelayModel())
+        {
+            NS_FATAL_ERROR("No propagation delay model added to the channel");
+        }
+        if (!m_channel->GetPropagationLossModel())
+        {
+            NS_FATAL_ERROR("No propagation loss model added to the channel");
+        }
+    }
+
     NetDeviceContainer devices;
     for (auto i = c.Begin(); i != c.End(); i++)
     {
@@ -342,7 +346,7 @@
     if (!device)
     {
         NS_LOG_INFO("LrWpanHelper::EnablePcapInternal(): Device "
-                    << device << " not of type ns3::LrWpanNetDevice");
+                    << device << " not of type ns3::lrwpan::LrWpanNetDevice");
         return;
     }
 
@@ -464,7 +468,7 @@
 
     oss.str("");
     oss << "/NodeList/" << nodeid << "/DeviceList/" << deviceid
-        << "/$ns3::LrWpanNetDevice/Mac/MacRx";
+        << "/$ns3::lrwpan::LrWpanNetDevice/Mac/MacRx";
     device->GetMac()->TraceConnect(
         "MacRx",
         oss.str(),
@@ -472,7 +476,7 @@
 
     oss.str("");
     oss << "/NodeList/" << nodeid << "/DeviceList/" << deviceid
-        << "/$ns3::LrWpanNetDevice/Mac/MacTx";
+        << "/$ns3::lrwpan::LrWpanNetDevice/Mac/MacTx";
     device->GetMac()->TraceConnect(
         "MacTx",
         oss.str(),
@@ -480,7 +484,7 @@
 
     oss.str("");
     oss << "/NodeList/" << nodeid << "/DeviceList/" << deviceid
-        << "/$ns3::LrWpanNetDevice/Mac/MacTxEnqueue";
+        << "/$ns3::lrwpan::LrWpanNetDevice/Mac/MacTxEnqueue";
     device->GetMac()->TraceConnect(
         "MacTxEnqueue",
         oss.str(),
@@ -488,7 +492,7 @@
 
     oss.str("");
     oss << "/NodeList/" << nodeid << "/DeviceList/" << deviceid
-        << "/$ns3::LrWpanNetDevice/Mac/MacTxDequeue";
+        << "/$ns3::lrwpan::LrWpanNetDevice/Mac/MacTxDequeue";
     device->GetMac()->TraceConnect(
         "MacTxDequeue",
         oss.str(),
@@ -496,7 +500,7 @@
 
     oss.str("");
     oss << "/NodeList/" << nodeid << "/DeviceList/" << deviceid
-        << "/$ns3::LrWpanNetDevice/Mac/MacTxDrop";
+        << "/$ns3::lrwpan::LrWpanNetDevice/Mac/MacTxDrop";
     device->GetMac()->TraceConnect(
         "MacTxDrop",
         oss.str(),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/helper/lr-wpan-helper.h ns-3.43/src/lr-wpan/helper/lr-wpan-helper.h
--- ns-3.42/src/lr-wpan/helper/lr-wpan-helper.h	2024-05-29 15:29:46.976073300 -0700
+++ ns-3.43/src/lr-wpan/helper/lr-wpan-helper.h	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors:
  *  Gary Pei <guangyu.pei@boeing.com>
@@ -50,23 +39,14 @@
 {
   public:
     /**
-     * \brief Create a LrWpan helper in an empty state.  By default, a
-     * SingleModelSpectrumChannel is created, with a
-     * LogDistancePropagationLossModel and a ConstantSpeedPropagationDelayModel.
-     *
-     * To change the channel type, loss model, or delay model, the Get/Set
-     * Channel methods may be used.
+     * \brief Create a LrWpan helper in an empty state.
      */
     LrWpanHelper();
 
     /**
-     * \brief Create a LrWpan helper in an empty state with either a
-     * SingleModelSpectrumChannel or a MultiModelSpectrumChannel.
+     * \brief Create a LrWpan helper in an empty state.
      * \param useMultiModelSpectrumChannel use a MultiModelSpectrumChannel if true, a
      * SingleModelSpectrumChannel otherwise
-     *
-     * A LogDistancePropagationLossModel and a
-     * ConstantSpeedPropagationDelayModel are added to the channel.
      */
     LrWpanHelper(bool useMultiModelSpectrumChannel);
 
@@ -95,6 +75,26 @@
     void SetChannel(std::string channelName);
 
     /**
+     * \tparam Ts \deduced Argument types
+     * \param name the name of the model to set
+     * \param [in] args Name and AttributeValue pairs to set.
+     *
+     * Add a propagation loss model to the set of currently-configured loss models.
+     */
+    template <typename... Ts>
+    void AddPropagationLossModel(std::string name, Ts&&... args);
+
+    /**
+     * \tparam Ts \deduced Argument types
+     * \param name the name of the model to set
+     * \param [in] args Name and AttributeValue pairs to set.
+     *
+     * Configure a propagation delay for this channel.
+     */
+    template <typename... Ts>
+    void SetPropagationDelayModel(std::string name, Ts&&... args);
+
+    /**
      * \brief Add mobility model to a physical device
      * \param phy the physical device
      * \param m the mobility model
@@ -103,6 +103,16 @@
 
     /**
      * \brief Install a LrWpanNetDevice and the associated structures (e.g., channel) in the nodes.
+     *
+     * If the channel is not already initialized, it will be created as either a
+     * SingleModelSpectrumChannel or a MultiModelSpectrumChannel, depending on the
+     * useMultiModelSpectrumChannel flag. Additionally, a ConstantSpeedPropagationDelayModel will be
+     * set as the default delay model if no delay model is specified, and a
+     * LogDistancePropagationLossModel will be added to the channel if no propagation loss models
+     * are defined.
+     *
+     * If the channel is already initialized but lacks either a PropagationDelayModel or a
+     * PropagationLossModel, an error will be raised.
      * \param c a set of nodes
      * \returns A container holding the added net devices.
      */
@@ -193,9 +203,30 @@
                              bool explicitFilename) override;
 
   private:
-    Ptr<SpectrumChannel> m_channel; //!< channel to be used for the devices
+    Ptr<SpectrumChannel> m_channel;      //!< channel to be used for the devices
+    bool m_useMultiModelSpectrumChannel; //!< indicates whether a MultiModelSpectrumChannel is used
+    std::vector<ObjectFactory> m_propagationLoss; ///< vector of propagation loss models
+    ObjectFactory m_propagationDelay;             ///< propagation delay model
 };
 
+/***************************************************************
+ *  Implementation of the templates declared above.
+ ***************************************************************/
+
+template <typename... Ts>
+void
+LrWpanHelper::AddPropagationLossModel(std::string name, Ts&&... args)
+{
+    m_propagationLoss.push_back(ObjectFactory(name, std::forward<Ts>(args)...));
+}
+
+template <typename... Ts>
+void
+LrWpanHelper::SetPropagationDelayModel(std::string name, Ts&&... args)
+{
+    m_propagationDelay = ObjectFactory(name, std::forward<Ts>(args)...);
+}
+
 } // namespace ns3
 
 #endif /* LR_WPAN_HELPER_H */
